/*************************************************************************
 * DISCLAIMER *
 * Services performed by FREESCALE in this matter are performed          *
 * AS IS and without any warranty. CUSTOMER retains the final decision   *
 * relative to the total design and functionality of the end product.    *
 * FREESCALE neither guarantees nor will be held liable by CUSTOMER      *
 * for the success of this project. FREESCALE disclaims all warranties,  *
 * express, implied or statutory including, but not limited to,          *
 * implied warranty of merchantability or fitness for a particular       *
 * purpose on any hardware, software ore advise supplied to the project  *
 * by FREESCALE, and or any product resulting from FREESCALE services.   *
 * In no event shall FREESCALE be liable for incidental or consequential *
 * damages arising out of this agreement. CUSTOMER agrees to hold        *
 * FREESCALE harmless against any and all claims demands or actions      *
 * by anyone on account of any damage, or injury, whether commercial,    *
 * contractual, or tortuous, rising directly or indirectly as a result   *
 * of the advise or assistance supplied CUSTOMER in connection with      *
 * product, services or goods supplied under this Agreement.             *
 *************************************************************************/

#ifndef _FLASH_OPERATION_API_H_
#define _FLASH_OPERATION_API_H_

#define PAGE_ERASE_ROUTINE_ADDR   0x27EC
#define PROGRAM_ROUTINE_ADDR      0x2759

extern char Src_Data[32];               //the data buffer save the data will be programmed to flash, Mzximum size is 32
extern char Data_Len ;                  //the valid data length in data buffer
extern unsigned int Obj_Start_Addr;     //0x88,89  keep start address where the data in buffer will be programmed
extern char Stat;                       //0x87 the return value of flash erase and program; 0x01: success, other value: failed
extern char Index;    

extern char Flash_Erase(unsigned char* Addr); //flash erase routine
extern char Flash_Program(void);              //flash program routine

#endif